% Aryeh Drager
% Math 53 Project

% Show Global Error of O(h^4), where h is the time step.
% Requires functions: finddxdt.m, showRK4.m

clear

j = 40; % number of points
t_final = 1; % final time, in units of "pentadays"
F = 8; % forcing term

% Vary h from 1e-3 to 1e-1 and compare to result obtained with h = 1e-6
result_neg1 = showRK4(F,j,1e-1,t_final);
result_neg2 = showRK4(F,j,1e-2,t_final);
result_neg3 = showRK4(F,j,1e-3,t_final);
result_neg6 = showRK4(F,j,1e-6,t_final);

results = [result_neg1 result_neg2 result_neg3 result_neg6];
results_adj = results;

% Calculate absolute error:
results_adj(:,1) = abs(results_adj(:,1) - results_adj(:,4));
results_adj(:,2) = abs(results_adj(:,2) - results_adj(:,4));
results_adj(:,3) = abs(results_adj(:,3) - results_adj(:,4));
results_adj(:,4) = abs(results_adj(:,4) - results_adj(:,4));

results_plot = results_adj(:,1:3);

figure(1)
loglog([1e-1 1e-2 1e-3],results_plot(1,:));
hold on
for it = 2:40
    loglog([1e-1 1e-2 1e-3],results_plot(it,:));
end
hold off
xlabel('Time Step, "pentadays"')
ylabel('Absolute Error (relative to result obtained with time step 10^-^6)')
title('Fourth-Order Error Behavior of Runge-Kutta Numerical Solution')
grid on
